{-# LANGUAGE FlexibleInstances #-}
module MapTest where

import MapList
import Prelude hiding (lookup)    
import Test.QuickCheck

-- Arbitrary-Instanz fr Map. 
-- Erzeugt eine Map zuflliger Lnge zwischen 10 und 20,
-- gefllt mit zuflligen Werten.
instance (Ord a, Arbitrary a, Arbitrary b)=> Arbitrary (Map a b) where
  arbitrary = do
    size <- choose (10, 20)
    a <- vector size
    b <- vector size
    return (foldl (\s (a, v)-> put a (Just v) s) empty (zip a b))

-- Die Eigenschaften

-- Lesen der leeren Map
prop_readEmpty :: Int-> Bool
prop_readEmpty a = 
  lookup a (empty :: Map Int String) == Nothing 
 
-- Lesen an derselben Stelle
prop_readPut :: Int-> Maybe String-> 
                Map Int String-> Bool
prop_readPut a v s = 
  lookup a (put a v s) == v

-- Lesen an anderer Stelle
prop_readPutOther :: Int-> Int-> Maybe String-> 
                     Map Int String-> Property
prop_readPutOther a b v s = 
  a /= b ==> lookup a (put b v s) == lookup a s

-- Schreiben an derselben Stelle
prop_putPut :: Int-> Maybe String-> Maybe String-> 
               Map Int String-> Bool
prop_putPut a v w s =
  put a w (put a v s) == put a w s

-- Schreiben an anderer Stelle
prop_putPutOther :: Int-> Maybe String-> Int-> 
                    Maybe String-> Map Int String-> 
                    Property        
prop_putPutOther a v b w s =
  a /= b ==> put a v (put b w s) == 
             put b w (put a v s)

main = do
  quickCheck prop_readEmpty
  quickCheck prop_readPut
  quickCheck prop_readPutOther
  quickCheck prop_putPut
  quickCheck prop_putPutOther
  
