module QueueTest where

import Queue
import Test.QuickCheck

-- Arbitrary-Instanz fr Queue 
-- Erzeugt eine Queue zuflliger Lnge zwischen 0 und 20, 
-- gefllt mit zuflligen Werten.
instance Arbitrary a=> Arbitrary (Qu a) where
  arbitrary = do
    size <- choose (0, 20) 
    els  <- vector size     
    return $ foldr enq empty els

prop_firstEmpty :: Int-> Qu Int->  Bool
prop_firstEmpty a q = 
  first (enq a empty) == a

prop_firstEnq :: Int-> Qu Int-> Property
prop_firstEnq a q =
  q /= empty ==> first (enq a q) == first q

prop_deqEnqEmpty :: Int-> Bool
prop_deqEnqEmpty a =
  deq (enq a empty) == empty

prop_deqEnq :: Int-> Qu Int-> Property
prop_deqEnq a q =
  q /= empty ==> deq (enq a q) == enq a (deq q)

prop_notEmptyEnq :: Int-> Qu Int-> Bool
prop_notEmptyEnq a q =
  enq a q /= empty

main = do
  Test.QuickCheck.quickCheck prop_firstEmpty
  Test.QuickCheck.quickCheck prop_firstEnq
  Test.QuickCheck.quickCheck prop_deqEnqEmpty
  Test.QuickCheck.quickCheck prop_deqEnq
  Test.QuickCheck.quickCheck prop_notEmptyEnq
  
