module StackTest where

import Stack
import Test.QuickCheck

-- Arbitrary-Instanz fr Stack
-- Erzeugt einen Stack zuflliger Lnge zwischen 0 und 20, 
-- gefllt mit zuflligen Werten.
instance Arbitrary alpha=> Arbitrary (St alpha) where
  arbitrary = do
    size <- choose (0, 20) 
    els  <- vector size     
    return $ foldr push empty els

prop_topPush :: Int-> St Int-> Bool
prop_topPush a s =
  top (push a s) == a

prop_popPush :: Int-> St Int-> Bool
prop_popPush a s =
  pop (push a s) == s

prop_pushNotEmpty :: Int-> St Int-> Bool
prop_pushNotEmpty a s =
  empty /= push a s

main = do
  Test.QuickCheck.quickCheck prop_topPush
  Test.QuickCheck.quickCheck prop_popPush
  Test.QuickCheck.quickCheck prop_pushNotEmpty

